VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4665
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2895
   LinkTopic       =   "Form1"
   ScaleHeight     =   4665
   ScaleWidth      =   2895
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResults 
      Height          =   2655
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   5
      Top             =   1920
      Width           =   2655
   End
   Begin VB.CommandButton cmdSolve 
      Caption         =   "Solve"
      Height          =   375
      Left            =   1080
      TabIndex        =   4
      Top             =   1440
      Width           =   735
   End
   Begin VB.TextBox txtValues 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   2520
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin VB.TextBox txtCoefficients 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   1695
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "="
      Height          =   255
      Left            =   2280
      TabIndex        =   3
      Top             =   600
      Width           =   255
   End
   Begin VB.Label lblVariables 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   1920
      TabIndex        =   2
      Top             =   120
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Load the augmented array.
' Column num_cols + 1 holds the result values.
' Column num_cols + 2 will hold the variables' final values.
Private Function LoadArray(ByRef num_rows As Integer, ByRef num_cols As Integer) As Double()
Dim value_rows() As String
Dim coef_rows() As String
Dim one_row() As String
Dim r As Integer
Dim c As Integer
Dim arr() As Double

    ' Build the augmented matrix.
    value_rows = Split(txtValues.Text, vbCrLf)
    coef_rows = Split(txtCoefficients.Text, vbCrLf)
    one_row = Split(coef_rows(0), " ")
    num_rows = UBound(coef_rows) + 1
    num_cols = UBound(one_row) + 1
    ReDim arr(1 To num_rows, 1 To num_cols + 2)
    For r = 1 To num_rows
        one_row = Split(coef_rows(r - 1), " ")
        For c = 1 To num_cols
            arr(r, c) = CDbl(one_row(c - 1))
        Next c
        arr(r, num_cols + 1) = CDbl(value_rows(r - 1))
    Next r

    LoadArray = arr
End Function
' Display the array's values in the Debug window.
Private Sub PrintArray(arr() As Double)
Dim r As Integer
Dim c As Integer

    For r = LBound(arr, 1) To UBound(arr, 1)
        For c = LBound(arr, 2) To UBound(arr, 2)
            Debug.Print arr(r, c), ;
        Next c
        Debug.Print ""
    Next r
    Debug.Print ""
End Sub

Private Sub cmdSolve_Click()
Const TINY As Double = 0.00001
Dim num_rows As Integer
Dim num_cols As Integer
Dim r As Integer
Dim c As Integer
Dim r2 As Integer
Dim tmp As Double
Dim factor As Double
Dim arr() As Double
Dim orig_arr() As Double
Dim txt As String

    ' Build the augmented matrix.
    arr = LoadArray(num_rows, num_cols)
    orig_arr = arr

    ' Display the initial array.
    'PrintArray arr

    ' Start solving.
    For r = 1 To num_rows - 1
        ' Zero out all entries in column r after this row.
        ' See if this row has a non-zero entry in column r.
        If Abs(arr(r, r)) < TINY Then
            ' Not a non-zero value. Try to swap with a later row.
            For r2 = r + 1 To num_rows
                If Abs(arr(r2, r)) > TINY Then
                    ' This row will work. Swap them.
                    For c = 1 To num_cols + 1
                        tmp = arr(r, c)
                        arr(r, c) = arr(r2, c)
                        arr(r2, c) = tmp
                    Next c
                    Exit For
                End If
            Next r2
        End If

        ' If this row has a non-zero entry in column r, skip this column.
        If Abs(arr(r, r)) > TINY Then
            ' Zero out this column in later rows.
            For r2 = r + 1 To num_rows
                factor = -arr(r2, r) / arr(r, r)
                For c = r To num_cols + 1
                    arr(r2, c) = arr(r2, c) + factor * arr(r, c)
                Next c
            Next r2
        End If
    Next r

    ' Display the upper-triangular array.
    'PrintArray arr

    ' See if we have a solution.
    If arr(num_rows, num_cols) = 0 Then
        ' We have no solution.
        txt = "No solution"
    Else
        ' Back solve.
        For r = num_rows To 1 Step -1
            tmp = arr(r, num_cols + 1)
            For r2 = r + 1 To num_rows
                tmp = tmp - arr(r, r2) * arr(r2, num_cols + 2)
            Next r2
            arr(r, num_cols + 2) = tmp / arr(r, r)
        Next r

        ' Display the results.
        txt = "    Values"
        For r = 1 To num_rows
            txt = txt & vbCrLf & "x" & Format$(r) & " = " & Format$(arr(r, num_cols + 2))
        Next r

        ' Verify.
        txt = txt & vbCrLf & "    Check:"
        For r = 1 To num_rows
            tmp = 0
            For c = 1 To num_cols
                tmp = tmp + orig_arr(r, c) * arr(c, num_cols + 2)
            Next c
            txt = txt & vbCrLf & Format$(tmp)
        Next r

        txt = Mid$(txt, Len(vbCrLf) + 1)
    End If

    txtResults.Text = txt
End Sub
Private Sub Form_Load()
    txtCoefficients.Text = _
        "9 3 4 1" & vbCrLf & _
        "4 3 4 1" & vbCrLf & _
        "1 1 1 1" & vbCrLf & _
        "2 3 4 5"
    lblVariables.Caption = _
        "x1" & vbCrLf & _
        "x2" & vbCrLf & _
        "x3" & vbCrLf & _
        "x4" & vbCrLf & _
        "." & vbCrLf & _
        "." & vbCrLf & _
        "."
    txtValues.Text = _
        "7" & vbCrLf & _
        "8" & vbCrLf & _
        "3" & vbCrLf & _
        "4"
End Sub



